mysite/enquetes/urls.py
from django.urls import path
from . import views

app_name = 'enquetes'
urlpatterns = [
    path('', views.IndexView.as_view(), name='index'),
    path(
        'pergunta/<int:id>/', views.DetalhesView.as_view(),
        name= 'detalhes'
    ),
    path(
        'pergunta/<int:id>/votacao', views.VotacaoView.as_view(),
        name= 'votacao'
    ),
    path(
        'pergunta/<int:id>/resultado', views.ResultadoView.as_view(),
        name= 'resultado'
    ),
]

mysite/mysite/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('enquetes.urls')),
]

mysite/enquetes/models.py
import datetime
from django.db import models
from django.utils import timezone


# Create your models here.
class Pergunta(models.Model):
    texto = models.CharField(max_length=200)
    # autor = models.CharField(max_length=80, null=True)
    data_publicacao = models.DateTimeField('Data de Publicação')
    # data_encerramento = models.DateField('Data de Encerramento', null=True)
    def __str__(self):
        return self.texto
    def publicada_recentemente(self):
        agora = timezone.now()
        passado_24hrs = agora - datetime.timedelta(days=1)
        return passado_24hrs <= self.data_publicacao <= agora

class Opcao(models.Model):
    texto = models.CharField(max_length=100)
    quant_votos = models.IntegerField(default=0)
    pergunta = models.ForeignKey(Pergunta, on_delete=models.CASCADE)
    def __str__(self):
        return self.texto

mysite/enquetes/views.py
from django.shortcuts import render, get_object_or_404
from django.http import HttpResponseRedirect
from django.urls import reverse
from django.views import generic
from django.utils import timezone
from .models import Pergunta, Opcao

class IndexView(generic.View):
    def get(self, request, *args, **kwargs):
        lista_perguntas = Pergunta.objects.filter(
            data_publicacao__lte = timezone.now()
        ).order_by('-data_publicacao')[:6]
        contexto = {'lista_perguntas': lista_perguntas,}
        return render(request, 'enquetes/index.html', contexto)

class DetalhesView(generic.View):
    def get(self, request, *args, **kwargs):
        id = self.kwargs['id']
        pergunta = get_object_or_404(Pergunta, pk=id)
        contexto = {'pergunta': pergunta,}
        return render(request, 'enquetes/detalhes.html', contexto)

class ResultadoView(generic.View):
    def get(self, request, *args, **kwargs):
        id = self.kwargs['id']
        pergunta = get_object_or_404(Pergunta, pk=id)
        contexto = {'pergunta': pergunta,}
        return render(request, 'enquetes/resultado.html', contexto)

class VotacaoView(generic.View):
    def post(self, request, *args, **kwargs):
        id = self.kwargs['id']
        pergunta = get_object_or_404(Pergunta, pk=id)
        try:
            selecionada = pergunta.opcao_set.get(pk=request.POST['id_opcao'])
        except (KeyError, Opcao.DoesNotExiste):
            contexto = {
                'pergunta': pergunta,
                'error_message': "Selecione uma opção válida",
            }
            return render(request, 'enquetes:detalhes', contexto)
        else:
            selecionada.quant_votos += 1
            selecionada.save()
            return HttpResponseRedirect(
                reverse('enquetes:resultado', args=(pergunta.id,))
            )

"""
-------------------------------------------------------------
Formas alternativas de representação de elementos de view


### INDEXAlternativa 1: função de view INDEX
######################################

def index(request):
    lista_perguntas = Pergunta.objects.order_by('-data_publicacao')[:6]
    contexto = {'lista_perguntas': lista_perguntas,}
    return render(request, 'enquetes/index.html', contexto)



### INDEX Alternativa 2: extendendo uma classe de view genérica
########################################################
class IndexView(generic.ListView):
    template_name = 'enquetes/index.html'
    context_object_name = 'lista_perguntas'
    def get_queryset(self):
        return Pergunta.objects.order_by('-data_publicacao')[:6]

------------------------------------------------------------------------
### DETALHES Alternativa 1: função de view
########################################################
def detalhes(request, id_pergunta):
    pergunta = get_object_or_404(Pergunta, pk=id_pergunta)
    contexto = { 'pergunta': pergunta, }
    return render(request, 'enquetes/detalhes.html', contexto)

### DETALHES Alternativa 2: extendendo uma classe de view genérica
########################################################

class DetalhesView(generic.DetailView):
    model = Pergunta
    template_name = 'enquetes/detalhes.html'

------------------------------------------------------------------------
### RESULTADO Alternativa 1: função de view
########################################################
def resultado(request, id_pergunta):
    pergunta = get_object_or_404(Pergunta, pk=id_pergunta)
    contexto = {'pergunta': pergunta,}
    return render(request, 'enquetes/resultado.html', contexto)

### RESULTADO Alternativa 2: extendendo uma classe de view genérica
########################################################
class ResultadoView(generic.DetailView):
    model = Pergunta
    template_name = 'enquetes/resultado.html'

---------------------------------------------------------------------
### VOTACAO: na forma de uma função view
########################################################
def votacao(request, id_pergunta):
    pergunta = get_object_or_404(Pergunta, pk=id_pergunta)
    try:
        selecionada = pergunta.opcao_set.get(pk=request.POST['id_opcao'])
    except (KeyError, Opcao.DoesNotExiste):
        contexto = {
            'pergunta': pergunta, 'error_message': "Selecione uma opção válida"
        }
        return render(request, 'enquetes:detalhes', contexto)
    else:
        selecionada.quant_votos += 1
        selecionada.save()
        return HttpResponseRedirect(
            reverse('enquetes: resultado', args=(pergunta.id,))
        )
"""

mysite/enquetes/templates/enquetes/detalhes.html
<html>
    <head>
        <title>App Enquetes</title>
    </head>
    <body>
        <h2>Aplicação de Enquete</h2>
        <hr/>
        <h4>Detalhes da Enquete #{{ pergunta.id }}</h4>
        <h4>{{ pergunta.texto }} <br/>
        (<i>{{ pergunta.data_publicacao}}</i></h4>
        {% if error_message %}
            <p><b>{{ error_message }}</b></p>
        {% endif %}
        <form method= "post" action= "{% url 'enquetes:votacao' pergunta.id %}">
            {% csrf_token %}
            {% for opcao in pergunta.opcao_set.all %}
                <input type= "radio" name="id_opcao" value="{{ opcao.id }}"
                        id="opcao{{ forloop.counter}}">
                <label for="opcao{{ forloop.counter}}">
                    {{ opcao.texto }}
                </label><br/>
            {% endfor %}
            <br/>
            <input type="submit" value="Registrar Voto">
        </form>
        <hr/>
        <a href="{% url 'enquetes:index' %">Voltar a página inicial</a>
    </body>
</html>

mysite/enquetes/templates/enquetes/index.html
<html>
    <head>
        <title>App Enquetes</title>
    </head>
    <body>
        <h1>Aplicação de Enquetes</h1>
        {% if lista_perguntas %}
            <ul>
                {% for pergunta in lista_perguntas %}
                    <li><a href="{% url 'enquetes:detalhes' pergunta.id %}">
                        {{ pergunta.texto }}
                    </a></li>
                {% endfor %}
            </ul>
        {% else %}
            <h3>Nenhuma enquete cadastrada até o momento!</h3>
        {% endif %}
    </body>
</html>

mysite/enquetes/templates/enquetes/resultado.html
<html>
    <head>
        <title>App Enquetes</title>
    </head>
    <body>
        <h2>Aplicação de Enquete</h2>
        <hr/>
        <h4>Resultado PARCIAL da Enquete #{{ pergunta.id }}</h4>
        <h4>{{ pergunta.texto }} <br/>
        (<i>{{ pergunta.data_publicacao}}</i>)</h4>
        <ul>
            {% for opcao in pergunta.opcao_set.all %}
                <li>{{ opcao.texto }} - {{ opcao.quant_votos }}
                voto{{ opcao.quant_votos|pluralize }}</li>
            {% endfor %}
        </ul>
        <hr/>
        <a href="{% url 'enquetes:index' %}">Voltar a página inicial</a> |
        <a href="{% url 'enquetes:detalhes' pergunta.id %}">Vote novamente!</a>
    </body>
</html>